<?php
require __DIR__.'/vendor/autoload.php';

use Ratchet\Server\IoServer;
use Ratchet\Http\HttpServer;
use Ratchet\WebSocket\WsServer;
use Ratchet\MessageComponentInterface;
use Ratchet\ConnectionInterface;


class MyWebSocketServer implements MessageComponentInterface {
  private $concurrentClientCount = 0;

  public function __construct() {
    $this->concurrentClientCount = 0;
  }

  public function onOpen(ConnectionInterface $conn) {
    $this->concurrentClientCount++;
    echo $this->concurrentClientCount . " concurrent clients are connected\n";
  }

  public function onMessage(ConnectionInterface $from, $data) {
    echo "Data received: ".$data."\n";
    $words = explode(" ", $data);
    $answer = eval('return '.$words[2].$words[1].$words[3].';');
    $from->send($answer);
    echo "Answer: ".$answer."\n";
  }

  public function onClose(ConnectionInterface $conn) {
    $this->concurrentClientCount--;
  }

 public function onError(ConnectionInterface $conn, \Exception $e) {
   echo "An error has occurred: {$e->getMessage()}\n";
   $conn->close();
 }
}

$server = IoServer::factory( new HttpServer(new WsServer(new MyWebSocketServer())),   28563 );
$server->run();
?>
